=== debian/changelog ===
planetblupi (1.15.0-5) unstable; urgency=medium

  * Fix d/copyright Files stanza for IBMPlex fonts
  * Generate oggfiles using csound-soundfont instead of the default timidity
    soundfont

 -- Didier Raboud <odyx@debian.org>  Fri, 22 Dec 2023 15:21:42 +0100

planetblupi (1.15.0-4) unstable; urgency=medium

  * Backport two upstream patches:
    - Enable the window icon on Linux
    - Change platinum, platinium and Platinum to Platinium

 -- Didier Raboud <odyx@debian.org>  Mon, 11 Dec 2023 13:34:51 +0100

planetblupi (1.15.0-3) unstable; urgency=medium

  * Update fonts' patch to use other fonts from Debian main:
    - fonts-vazirmatn (for Arabic)
    - culmus (for Hebrew)

 -- Didier Raboud <odyx@debian.org>  Tue, 26 Sep 2023 07:50:14 +0200

planetblupi (1.15.0-2) unstable; urgency=medium

  * Add 1.15.0-1 changelog, missing from upload
  * Drop d/salsa-ci.yml in favour of repo-level configuration
  * Bump S-V to 4.6.2

 -- Didier Raboud <odyx@debian.org>  Mon, 25 Sep 2023 17:07:36 +0200

planetblupi (1.15.0-1) unstable; urgency=medium

  * New 1.15.0 upstream release
  * Re-add myself to Uploaders
  * Fix watch file for rc* versions
  * Build-Depends:
    - Add libsdl2-ttf to B-D
    - Bump libsdl-kitchinsink B-D to 1.0.11 (Closes: #1051112)

 -- Didier 'OdyX' Raboud <odyx@debian.org>  Mon, 25 Sep 2023 09:54:46 +0200
