=== debian/control ===
Source: planetblupi
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Didier Raboud <odyx@debian.org>,
Section: games
Priority: optional
Build-Depends:
 argagg-dev,
 cmake,
 debhelper-compat (= 13),
 libsdl-kitchensink-dev (>= 1.0.11),
 libsdl2-dev,
 libsdl2-image-dev,
 libsdl2-mixer-dev,
 libsdl2-ttf-dev,
 pkg-config,
 ronn,
Build-Depends-Indep:
 csound-soundfont,
 timidity,
 vorbis-tools,
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/games-team/planetblupi
Vcs-Git: https://salsa.debian.org/games-team/planetblupi.git
Homepage: https://blupi.org
Rules-Requires-Root: no

Package: planetblupi
Architecture: any
Depends:
 planetblupi-common (>= ${source:Version}),
 planetblupi-music-ogg (>= ${source:Version}) | planetblupi-music-midi (>= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Planet Blupi - A delirious spell-binding game
 Planet Blupi is a strategy and adventure game. It subtly blends action with
 thought-provoking challenges. Behind the quiet and gentle facade, you'll enjoy
 a fascinating diversion full of surprises.

Package: planetblupi-common
Architecture: all
Multi-Arch: foreign
Depends:
 culmus,
 fonts-vazirmatn,
 ${misc:Depends},
Recommends:
 planetblupi (>= ${source:Version}),
Enhances:
 planetblupi,
Description: Planet Blupi - A delirious spell-binding game - data
 Planet Blupi is a strategy and adventure game. It subtly blends action with
 thought-provoking challenges. Behind the quiet and gentle facade, you'll enjoy
 a fascinating diversion full of surprises.
 .
 This package contains the architecture-independent game data.

Package: planetblupi-music-midi
Architecture: all
Multi-Arch: foreign
Depends:
 fluidr3mono-gm-soundfont | timgm6mb-soundfont | fluid-soundfont-gm,
 ${misc:Depends},
Recommends:
 planetblupi (>= ${source:Version}),
Enhances:
 planetblupi,
Description: Planet Blupi - A delirious spell-binding game - MIDI music
 Planet Blupi is a strategy and adventure game. It subtly blends action with
 thought-provoking challenges. Behind the quiet and gentle facade, you'll enjoy
 a fascinating diversion full of surprises.
 .
 This package contains the lightweight MIDI music

Package: planetblupi-music-ogg
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Recommends:
 planetblupi (>= ${source:Version}),
Enhances:
 planetblupi,
Description: Planet Blupi - A delirious spell-binding game - Ogg music
 Planet Blupi is a strategy and adventure game. It subtly blends action with
 thought-provoking challenges. Behind the quiet and gentle facade, you'll enjoy
 a fascinating diversion full of surprises.
 .
 This package contains the heavyweight OGG music.
