=== debian/changelog ===
planetblupi (1.15.1-2) unstable; urgency=medium

  * Team Upload
  * Fix FBTFS with CMake 4 (Closes: #1113411)
  * Depends on fonts-culmus instead of transitional culmus (Closes: #1111135)
  * Revert changes outside of debian/

 -- Alexandre Detiste <tchet@debian.org>  Sat, 04 Oct 2025 14:34:31 +0200

planetblupi (1.15.1-1) unstable; urgency=medium

  * New 1.15.1 upstream release
    - Drop two patches that were from upstream
  * Bump S-V to 4.7 without changes needed
  * B-D: Replace pkg-config by pkgconf
  * d/copyright: list the appdata xml, update years

 -- Didier Raboud <odyx@debian.org>  Fri, 26 Apr 2024 13:45:48 +0200
