=== debian/control ===
--- 
+++ 
@@ -13,17 +13,16 @@
  libsdl2-image-dev,
  libsdl2-mixer-dev,
  libsdl2-ttf-dev,
- pkg-config,
+ pkgconf,
  ronn,
 Build-Depends-Indep:
  csound-soundfont,
  timidity,
  vorbis-tools,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/games-team/planetblupi
 Vcs-Git: https://salsa.debian.org/games-team/planetblupi.git
 Homepage: https://blupi.org
-Rules-Requires-Root: no
 
 Package: planetblupi
 Architecture: any
@@ -41,7 +40,7 @@
 Architecture: all
 Multi-Arch: foreign
 Depends:
- culmus,
+ fonts-culmus,
  fonts-vazirmatn,
  ${misc:Depends},
 Recommends:
