=== debian/watch ===
version=4
opts=uversionmangle=s/[_\.\-\+]?(rc|alpha|beta)/~$1/ \
  https://github.com/blupi-games/planetblupi/tags .*/v?@ANY_VERSION@@ARCHIVE_EXT@
